/* ==== iwr-texture.c ==== */

#include <math.h>
#include "SDL.h"

/* low whitening gives original colour (high saturation).
   high whitening gives white (low saturation, high value) */
Uint8 iwr_whiteout(Uint8 colourcomponent,double whitening) {
   return (colourcomponent+((255-colourcomponent)*whitening));
}

/* low "value" returns black levels.
   high "value" returns original colour. */
Uint8 iwr_unblacken(Uint8 colourcomponent,double value) {
   if (value>=1) {printf("value:%f ",value);value=1;}
   if (value<0) {printf("value:%f ",value);value=0;}
   return (colourcomponent*value);
}


/* CURRENTLY this is hardcoded, for testing. WILL be replaced by
something programmable, possibly hooking into Guile. */
void iwr_getrgbtexture(int x,int y,int z,Uint8 *r,Uint8 *g,Uint8 *b) {
   double level=cos((z*3.1415926)/16);
   level=(level+1)/2.8;
   /* *r=64+(191*level); */
   *r=iwr_whiteout(64,level);
   /* *g=36+(219*level); */
   *g=iwr_whiteout(36,level);
   /* *b=8+(247*level); */
   *b=iwr_whiteout(8,level);
   return;
}

